<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { softwareFasterDataHelper } from '../../services/software-faster.service';
import {
  SoftwareFasterCaseStudies,
  SoftwareFasterCustomerLogos,
  SoftwareFasterDevSecOps,
  SoftwareFasterFeaturedContent,
  SoftwareFasterHero,
} from '~/components/software-faster/index.vue';
import { NextStep } from '~/components/common/index.vue';
import { getPageMetadata } from '~/common/meta';

import { CONTENT_TYPES } from '~/common/content-types';
import { getClient } from '~/plugins/contentful.js';
import { FooterEditLinkMixin, LivePreviewMixin } from '~/mixins';
import { ContentfulLivePreview } from '@contentful/live-preview';
import { convertToCaseSensitiveLocale } from '~/common/util';

export default Vue.extend({
  name: 'SoftwareFasterPage',
  components: {
    SoftwareFasterHero,
    SoftwareFasterCustomerLogos,
    SoftwareFasterFeaturedContent,
    SoftwareFasterDevSecOps,
    SoftwareFasterCaseStudies,
    NextStep,
  },
  mixins: [LivePreviewMixin, FooterEditLinkMixin],
  async asyncData({ i18n }: any) {
    try {
      const { items } = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'sys.id': '6FiWTB7Jmxm04fdatrvZ6M',
        include: 10,
        locale: convertToCaseSensitiveLocale(i18n.locale),
      });
      const { pageContent, seoMetadata } = items[0].fields;
      const spaceId = items[0].sys.space.sys.id;
      const entryId = items[0].sys.id;
      const content = softwareFasterDataHelper(pageContent, seoMetadata);

      return { content, items, spaceId, entryId };
    } catch (e) {
      throw new Error(e);
    }
  },
  head(): MetaInfo {
    return getPageMetadata(
      (this as any).content,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
  mounted() {
    if (this.isPreview) {
      const unsubscribeFn = ContentfulLivePreview.subscribe({
        data: this.items,
        callback: (updatedData) =>
          (this.content = softwareFasterDataHelper(
            updatedData[0].fields.pageContent,
            updatedData[0].fields.seoMetadata,
          )),
      });
      this.livePreviewSubscriptions.push(unsubscribeFn);
    }
  },
});
</script>

<template>
  <section class="software-faster">
    <SoftwareFasterHero :data="content.hero" />
    <SoftwareFasterFeaturedContent :data="content.featured_content" />
    <SlpContainer>
      <SoftwareFasterCustomerLogos
        :data="content.customer_logos"
        :data-aos="'fade-up'"
        :data-aos-duration="1600"
        :data-aos-offset="200"
      />
    </SlpContainer>
    <SoftwareFasterDevSecOps :data="content.devsecops" />
    <SoftwareFasterCaseStudies
      id="case-studies"
      :data="content.by_industry_case_studies"
      :offset="1"
      data-slippers-scroll="case-studies"
    />
    <SlpContainer variant="gradient">
      <NextStep />
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.fade-enter-active,
.fade-leave-active {
  transition: opacity 0.4s ease-out;
}

.fade-enter,
.fade-leave-to {
  opacity: 0;
}
.slide-enter-active,
.slide-leave-active {
  transition: opacity 0.4s ease-in;
}

.slide-enter,
.slide-leave-to {
  opacity: 0;
}
.modal {
  background: transparent;
  display: flex;
  flex-direction: column;
  margin-top: $spacing-160;

  &__backdrop {
    position: fixed;
    top: 0;
    bottom: 0;
    left: 0;
    right: 0;
    background-color: rgba($color-surface-700, 0.85);
    display: flex;
    justify-content: center;
    align-items: flex-start;
    z-index: 1040;
  }
}
</style>
